// EventThreadView.cpp : implementation of the CEventThreadView class
//

#include "stdafx.h"
#include "EventThread.h"

#include "EventThreadDoc.h"
#include "EventThreadView.h"
#include "afxmt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CEvent comEventStart;
CEvent comEventEnd;

/////////////////////////////////////////////////////////////////////////////
// CEventThreadView

IMPLEMENT_DYNCREATE(CEventThreadView, CView)

BEGIN_MESSAGE_MAP(CEventThreadView, CView)
	//{{AFX_MSG_MAP(CEventThreadView)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventThreadView construction/destruction

CEventThreadView::CEventThreadView()
{
	// TODO: add construction code here

}

CEventThreadView::~CEventThreadView()
{
}

BOOL CEventThreadView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CEventThreadView drawing

void CEventThreadView::OnDraw(CDC* pDC)
{
	CEventThreadDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CEventThreadView diagnostics

#ifdef _DEBUG
void CEventThreadView::AssertValid() const
{
	CView::AssertValid();
}

void CEventThreadView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CEventThreadDoc* CEventThreadView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEventThreadDoc)));
	return (CEventThreadDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEventThreadView message handlers

UINT EventThread(LPVOID pParam)
{
    BOOL runThread = TRUE;

	HWND hWnd = (HWND) pParam;
	::MessageBox(hWnd, "Thread started.",
		"Thread Message",
		MB_ICONEXCLAMATION | MB_OK);

    comEventStart.Lock();

	::MessageBox(hWnd, "Thread processing.",
		"Thread Message",
		MB_ICONEXCLAMATION | MB_OK);

    while(runThread)
    {
        // Perform the thread's task here.
        int retCode = ::WaitForSingleObject(
            comEventEnd.m_hObject, 0);
        if (retCode == WAIT_OBJECT_0)
            runThread = FALSE;
    }

	::MessageBox(hWnd, "Thread ending.",
		"Thread Message",
		MB_ICONEXCLAMATION | MB_OK);

    return 0;
}

int CEventThreadView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
    HWND hWnd = GetSafeHwnd();
    AfxBeginThread(EventThread, hWnd);

	return 0;
}


void CEventThreadView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
    comEventStart.SetEvent();

	CView::OnLButtonDown(nFlags, point);
}

void CEventThreadView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
    comEventEnd.SetEvent();

	CView::OnRButtonDown(nFlags, point);
}
